<?
function dprintf( $s )
{
  global $debug_flag;
  if ( $debug_flag == 1 ) mprint( $s );
}

function inetq_encode( $s )
{
  $s = base64_encode( $s );             
  $s = urlencode( $s );
  return( $s );
}

function inetq_decode( $s )
{
  $s = base64_decode( $s );             
  $s = urldecode( $s );
  return( $s );
}

function os_type()
{
  $http_user_agent = getenv( "HTTP_USER_AGENT" );
  if ( ereg( "(Linux)", $http_user_agent, $reg ) ) return( $reg[1] );
  if ( ereg( "(Mac)", $http_user_agent, $reg ) ) return( $reg[1] );
  return( "other" );
}

function browser_type()
{
  global $target_browser;
  if ( $target_browser == "auto" )
  {
    $http_user_agent = getenv( "HTTP_USER_AGENT" );
    if ( ereg( "(^Mozilla)", $http_user_agent, $reg ) )
    {
      $t = $reg[1];
      if ( ereg( "(MSIE)", $http_user_agent, $reg ) )
        $t = $reg[1];
      return( $t );
    }
    if ( ereg( "(^DoCoMo)", $http_user_agent, $reg ) ) return( $reg[1] );
    return( "other" );
  }
  else
  {
    return( $target_browser ); // obey specified browser
  }
}

function e2s( $s )
{
  return( mb_convert_encoding( $s, "SJIS", "EUC-JP" ) );
}

function mconv( $s )
{   
  if ( os_type() == "Linux" )
    return( $s );
  else       
    return( e2s($s) );
}          

function mprint( $out )
{   
  global $inetq_http_output;
  if ( $sys_http_output == "pass" )
  {
    print( $out );
  }
  else
  {
    if ( os_type() == "Linux" )
      print( $out );
    else       
      print( e2s( $out ) );
  }
}          

function meta_language()
{
  if ( os_type() == "Linux" )
    $code = "x-euc-jp";
  else
    $code = "x-sjis";
  printf( "<meta http-equiv=\"Content-Type\" ".
          "content=\"text/html; charset=%s\">", $code );
}

function mbasename( $path )
{
dprintf( "path=$path<br>" );
  $type = os_type();
dprintf( "type=$type<br>" );
  if ( $type == "Linux" )
  {
    $array = explode( "/", $path );
    $n = count( $array );
    $filename = $array[$n-1];
    return( $filename );
  }
  elseif ( $type == "Macintosh" )
  {
    $array = explode( ":", $path );
    $n = count( $array );
    $filename = $array[$n-1];
    return( $filename );
  }
  else
  {
    $array = explode( "\\", $path );
    $n = count( $array );
    $filename = $array[$n-1];
    return( $filename );
  }
}

function applebasename( $path )
{
  $array = explode( ":", $path );
  $n = count( $array );
  $filename = $array[$n-1];
  return( $filename );
}

function error( $msg, $flag )
{
  if ( $flag == "IN" ) // inside html tag
  {
    mprint( $msg );
  }
  else
  {
    print( "<html>\n" );
    print( "<head>\n" );
    meta_language();
    print( "</head>\n" );
    print( "<body>\n" );
    mprint( $msg );
    print( "</body>\n" );
    print( "</html>\n" );
    exit;
  }
}

function insert_log( $con )
{
  global $REQUEST_URI;
  global $PHP_AUTH_USER;
  global $get_log_info;
  if ( $get_log_info == "Y" )
  {
    $http_user_agent = getenv( "HTTP_USER_AGENT" );
    $remote_addr = getenv( "REMOTE_ADDR" );
    $remote_port = getenv( "REMOTE_PORT" );
    $cdate = date( "Y-m-d H:i:s" );
    $qs = "insert into log values( '$REQUEST_URI','$PHP_AUTH_USER','$http_user_agent','$remote_addr','$remote_port','','$cdate' )";
    $res = pg_Exec( $con, $qs );
    if ( !$res )
    {
      printf( "SQL EXEC ERROR:%s<br>", $qs );
      exit;
    }
  }
}

function sql_exec_noexit( $con, $qs )
{
  dprintf( sprintf("%s<br>",$qs) );
  $result = pg_Exec( $con, $qs );
  return( $result );
}

function sql_exec( $con, $qs )
{
  dprintf( sprintf("%s<br>",$qs) );
  $result = pg_Exec( $con, $qs );
  if ( !$result )
  {
    printf( "%s<br>", $qs );
    print( "SQL EXEC ERROR<br>" );
    exit;
  }
  return( $result );
}

function sql_begin( $con )
{
  $result = pg_exec( $con, "begin" );
  return( $result );
}

function sql_abort( $con )
{
  $result = pg_exec( $con, "abort" );
  return( $result );
}

function sql_end( $con )
{
  $result = pg_exec( $con, "end" );
  return( $result );
}

function sql_lo_exec( $con, $qs )
{
  $result = pg_Exec( $con, $qs );
  if ( !$result )
  {
    printf( "%s<br>", $qs );
    print( "SQL EXEC ERROR<br>" );
    exit;
  }
  return( $result );
}

function lo_write( $con, $file, &$oid )
{
  $fd = fopen( $file, "r" );
  if ( !$fd ) return( 0 );
  $size = filesize( $file );
  $img = fread( $fd, $size );
  fclose( $fd );

  $oid = pg_locreate( $con );
  if ( !$oid ) return( 0 );
  $lobj = pg_loopen( $con, $oid, "w" );
  if ( !$lobj )
  {
    pg_lounlink( $con, $oid );
    return( 0 );
  }
  $ret = pg_lowrite( $lobj, $img );
  if ( !$ret )
  {
    pg_lounlink( $con, $oid );
    pg_loclose( $lobj );
    return( 0 );
  }
  pg_loclose( $lobj );
  return( 1 );
}

function sql_datestyle_iso( $con )
{
  $res = pg_exec( $con, "set datestyle to 'iso'" );
  return( $res );
}

function MyCompanyWebURL()
{
  global $my_company_web_protocol;
  global $my_company_web_host;
  global $my_company_web_dir;
  return( $my_company_web_protocol."://".$my_company_web_host.$my_company_web_dir );
}

function MyCompanyIWebURL()
{
  global $my_company_iweb_protocol;
  global $my_company_iweb_host;
  global $my_company_iweb_dir;
  return( $my_company_iweb_protocol."://".$my_company_iweb_host.$my_company_iweb_dir );
}

function GetCompanyName( $con, $id, &$stat )
{
  $query_string = "select name from company where id='$id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "name" );
  return( $result );
}

function GetCategoryCodefrCompanyId( $con, $id, &$stat )
{
  $query_string = "select category from company where id='$id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "category" );
  return( $result );
}

function IsAuthUser( $con, $company_id, $user_id, &$stat )
{
  $query_string = "select level from user_list where ".
                  "company_id='$company_id' and user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "level" );
  if ( $result == "authorized" ) return( "YES" );
  return( "NO" );
}

function IsSuperUser( $con, $user_id, &$stat )
{
  $query_string = "select level from user_list where ".
                  "user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "level" );
  if ( $result == "super" ) return( "YES" );
  return( "NO" );
}

function IsPrimaryUser( $con, $user_id, &$stat )
{
  $query_string = "select status from user_list where ".
                  "user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "status" );
  if ( $result == 1 ) return( "YES" );
  return( "NO" );
}

function GetGuestPersonID( $con, $guest_id, &$stat )
{
  $query_string = "select person_id from guest_list where ".
                  "guest_id='$guest_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "person_id" );
  return( $result );
}

function IsGuestPersonReady( $con, $guest_id, &$stat )
{
  $query_string = "select person_id from guest_list where ".
                  "guest_id='$guest_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "person_id" );
  if ( $result != "" ) return( "YES" );
  return( "NO" );
}

function IsPartnerAcceptable( $con, $partner_id, $partner_login_id,
                              $partner_login_passwd, &$permission, &$err_msg )
{
  if ( $partner_login_id == "" || $partner_login_passwd == "" )
  {
    $err_msg = "ҤȤƤΥID 뤤 ".
               "ѥɤåȤƤޤ";
    return( "UNDEFINED" );
  }
  $qs = "select * from partner where company_id='$partner_id'";
  $res = pg_exec( $con, $qs );
  if ( !$res )
  {
    $err_msg = $qs;
    return( "SQLERROR" );
  }
  $num = pg_NumRows( $res );
  if ( $num == 0 )
  {
    $err_msg =  sprintf( "ID %s ϼҤȤƤϿޤ",
                         $partner_id );
    return( "NOTREGISTERED" );
  }
  $accept_id = pg_Result( $res, 0, "accept_id" );
  $accept_passwd = pg_Result( $res, 0, "accept_passwd" );
  $permission = pg_Result( $res, 0, "permission" );
  if ( $accept_id=$partner_login_id && $accept_passwd=$partner_login_passwd )
  {
    $err_msg = "";
    return( "OK" );
  }
  else
  {
    $err_msg = "ID ⤷ ѥɤŬ礷ޤ";
    return( "NOTMATCHED" );
  }
}

function GetGuestName( $con, $user_id, &$stat )
{
  $query_string = "select name from guest_list where guest_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "name" );
  return( $result );
}

function GetGuestCompanyName( $con, $user_id, &$stat )
{
  $query_string = "select company_name from guest_list where ".
                  "guest_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "company_name" );
  return( $result );
}

function GetUserEmailAddress( $con, $user_id, &$stat )
{
  $query_string = "select email from user_list where ".
                  "user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "email" );
  return( $result );
}

function GetUserName( $con, $user_id, &$stat )
{
  $query_string = "select name from user_list where ".
                  "user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "name" );
  return( $result );
}

function GetUserHomeDir( $con, $user_id, &$stat )
{
  global $users_home_dir;
  $query_string = "select home_dir from user_list where ".
                  "user_id='$user_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "home_dir" );
  return( $users_home_dir.$result );
}

function GetPartnerName( $con, $partner_id, &$stat )
{
  $query_string = "select company_name from partner where company_id='$partner_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "company_name" );
  return( $result );
}

function GetPrimaryUserId( $con, &$stat )
{
  $query_string = "select user_id from user_list where status=1";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  $num = pg_NumRows( $result );
  if ( $num > 0 )
  {
    $result = pg_Result( $result, 0, "user_id" );
  }
  else
  {
    $stat = 0;
    $result = 0;
  }
  $stat = 1;
  return( $result );
}

function GetCategoryName( $con, $code, &$stat )
{
  $query_string = "select name from category where code='$code'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "name" );
  return( $result );
}

function GetGroupXdayOffset( $con, $group_id, &$stat )
{
  $query_string = "select xday_offset from group_list where id='$group_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "xday_offset" );
  return( $result );
}

function GetGroupSendEmail( $con, $group_id, &$stat )
{
  $query_string = "select send_email from group_list where id='$group_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "send_email" );
  return( $result );
}

function GetDocumentRoot( $con, $company_id, &$stat )
{
  $query_string = "select document_root from company where id='$company_id'";
  $result = pg_exec( $con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $result = pg_Result( $result, 0, "document_root" );
  return( $result );
}

function GetCompanyDBHost( $sys_con, $company_id, &$host, &$db, &$mhost, &$mdb, &$stat )
{
  $query_string = "select * from company where id='$company_id'";
  $result = pg_Exec( $sys_con, $query_string );
  if ( !$result )
  {
    $stat = 0;
    return( $result );
  }
  if ( pg_numrows( $result ) == 0 )
  {
    $stat = 0;
    return( $result );
  }
  $stat = 1;
  $host = pg_Result( $result, 0, "db_host" );
  $db = pg_Result( $result, 0, "db_name" );
  $mhost = pg_Result( $result, 0, "mdb_host" );
  $mdb = pg_Result( $result, 0, "mdb_name" );
  return( $result );
}

function NMonthDate( $n )
{
  $y = date( "Y" );
  $m = date( "m" );
  $d = date( "d" );
  $st = mktime( 0, 0, 0, $m+$n, $d, $y );
  $s = date( "Y-m-d", $st );
  return( $s );
}

function okdate( $dd, &$s )
{
  global $century2x;
  $s = $dd;
  if ( ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $dd, $reg) )
  {
    $y = $reg[1];
    $m = $reg[2];
    $d = $reg[3];
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})", $dd, $reg) )
  {
    $y = $reg[1];
    $m = $reg[2];
    $d = $reg[3];
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("([0-9]{1,2})-([0-9]{1,2})", $dd, $reg) )
  {
    $y = date( "Y" );
    $m = $reg[1];
    $d = $reg[2];
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("([0-9]{1,2})/([0-9]{1,2})", $dd, $reg) )
  {
    $y = date( "Y" );
    $m = $reg[1];
    $d = $reg[2];
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("(^[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9])", $dd, $reg) )
  {
    $y = substr( $dd, 0, 4 );
    $m = substr( $dd, 4, 2 );
    $d = substr( $dd, 6, 2 );
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("(^[0-9][0-9][0-9][0-9][0-9][0-9])", $dd, $reg) )
  {
    $y = $century2x . substr( $dd, 0, 2 );
    $m = substr( $dd, 2, 2 );
    $d = substr( $dd, 4, 2 );
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  elseif ( ereg("(^[0-9][0-9][0-9][0-9])", $dd, $reg) )
  {
    $y = date( "Y" );
    $m = substr( $dd, 0, 2 );
    $d = substr( $dd, 2, 2 );
    if ( checkdate( $m, $d, $y ) )
    {
      $s = $y . "-" . $m . "-" . $d;
      return( 1 );
    }
    else
    {
      return( 0 );
    }
  }
  else
  {
    return( 0 );
  }
}

function oktime( $t )
{
// printf( "t=%s<br>", $t );
  $reg = "";
  if ( ereg("([012]?[0-9]):([0-5][0-9]):([0-5][0-9])(am|pm|AM|PM)?", $t, $reg) )
  {
    if ( ereg("(am|pm|AM|PM)", $reg[4]) )
    {
      if ( $reg[1] > 12 ) return( 0 );
    }
    return( 1 );
  }
  elseif ( ereg("([012]?[0-9]):([0-5][0-9])(am|pm|AM|PM)?", $t, $reg) )
  {
    if ( ereg("(am|pm|AM|PM)", $reg[3]) )
    {
      if ( $reg[1] > 12 ) return( 0 );
    }
    return( 1 );
  }
  else
  {
    return( 0 );
  }
  return( 1 );
}

function oktel( $tel, &$s )
{
  $array = explode( "-", $tel );
  $n = count( $array );
  $t = "";
  for ( $i=0;$i<$n;$i++ )
    $t = $t.$array[$i];
  
  $reg = "";
  if ( ereg("(^[0-9]+$)", $t, $reg) )
  {
    $s = $t;
    return( 1 );
  }
  else
  {
    $s = $tel;
    return( 0 );
  }
}

function okint( $n )
{
  if ( ereg("(^[0-9]+$)", $n, $reg) ) return( 1 );
  return( 0 );
}

function okuserid( $p )
{
  if ( ereg("(^([0-9|a-z|A-Z])([0-9|a-z|A-Z|-])*([0-9|a-z|A-Z])$)", $p, $reg) )
    return( 1 );
  return( 0 );
}

function okfilename( $f )
{
  if ( ereg("(^([0-9|a-z|A-Z|/])([0-9|a-z|A-Z|/|.])*([0-9|a-z|A-Z])$)", $f, $reg) ) return( 1 );
  return( 0 );
}

function okzip3( $z )
{
  if ( ereg("(^[0-9][0-9][0-9]$)", $z, $reg) ) return( 1 );
  return( 0 );
}

function okzip4( $z )
{
  if ( ereg("(^[0-9][0-9][0-9][0-9]$)", $z, $reg) ) return( 1 );
  return( 0 );
}

function okdatetime( $dt, &$s, $flag )
{
  $s = $dt;
  $ddtt = explode( " ", $dt );
  if ( okdate( $ddtt[0], $d ) )
  {
    if ( $ddtt[1] != "" )
    {
      if ( oktime( $ddtt[1] ) )
      {
        $s = $d . " " . $ddtt[1];
        return( 1 );
      }
    }
    else
    {
      if ( $flag == "start" )
        $s = $d . " 00:00:00";
      else
        $s = $d . " 23:59:59";
      return( 1 );
    }
  }
  return( 0 );
}

function reverse( $s )
{
  $r = "";
  $l = strlen( $s );
  for ( $i=$l-1;$i>=0;$i-- )
    $r .= $s[$i];
  return( $r );
}

function sprintprice( $p )
{
  $ps = sprintf( "%d", $p );
  $l = strlen( $ps );
  $s = "";
  $j = 0;
  for ( $i=$l-1;$i>=0;$i-- )
  {
     $s .= $ps[$i];
     $j ++;
     if ( $j == 3 && $i > 0 )
     {
       $s .= ",";
       $j = 0;
     }
  }
  return( reverse($s) );
}

function sprintdate6( $d )
{
  $array = explode( " ", $d );
  $array = explode( "-", $array[0] );
  $y = substr( $array[0], 2, 2 );
  $m = $array[1];
  $d = $array[2];
  return( $y."-".$m."-".$d );
}

function encode_hex_string( $s )
{
  $len = strlen( $s );
  $hex_string = "";
  for ( $i=0;$i<$len;$i++ )
  {
    $b = ord( substr($s,$i,1) );
    $hex_string .= sprintf( "%02x", $b );
  }
  return( $hex_string );
}

function decode_hex_string( $hex_string )
{
  $hex_s = $hex_string;
  $out = "";
  while( $hex_s != "" )
  {
    $hex = substr( $hex_s, 0, 2 );
    $dec = hexdec( $hex );
    $out .= chr( $dec );
    $hex_s = substr( $hex_s, 2 );
  }
  return( $out );
}

function octstr2ord( $in )
{
  $c1 = ord(substr($in,0,1)) - 48;
  $c2 = ord(substr($in,1,1)) - 48;
  $c3 = ord(substr($in,2,1)) - 48;
  $out = $c1*8*8 + $c2*8 + $c3;
  return( $out );
}

function decode_ai_path( $in )
{
  $len = strlen( $in );
  $out = "";
  for ( $i=0;$i<$len;$i++ )
  {
    if ( substr($in,$i,2) == "\\\\" ) // '\\' found
    {
      $out .= "\\\\";
      $i++;
    }
    else if ( substr($in,$i,1) == "\\" ) // '\123' found
    {
      $oct = substr( $in,$i+1,3 );
      $out .= octstr2ord( $oct );
      $i = $i + 3;
    }
    else
    {
      $out .= substr( $in,$i,1 );
    }
  }
  return( $out );
}

function get_service_paths( $serv_file, $proc_code, &$sample_path, &$template_path, &$library_path, &$print_path )
{
  $fp = fopen( $serv_file, "r" );
  while( !feof( $fp ) )
  {
    $w_read = fgets( $fp, 1024 );
    if ( substr( $w_read, 0, 1 ) == "#" ) continue;
    $w_line = explode( "\n", $w_read );
    $w_array = explode( "\t", $w_line[0] );
    if ( $w_array[0] == $proc_code )
    {
      $sample_path = $w_array[1];
      $template_path = $w_array[2];
      $library_path = $w_array[3];
      $print_path = $w_array[4];
      fclose( $fp );
      return;
    }
  }
  fclose( $fp );
  die( "cannot find proc_code=$proc_cope in services" );
}

function get_font_info( $font_id, &$name, &$type, &$tsume )
{
  global $fonts_file;
  $fp = fopen( $fonts_file, "r" );
  while( !feof( $fp ) )
  {
    $w_read = fgets( $fp, 1024 );
    if ( substr( $w_read, 0, 1 ) == "#" ) continue;
    $w_line = explode( "\n", $w_read );
    $w_array = explode( "\t", $w_line[0] );
    if ( $w_array[0] == $font_id )
    {
      $name = $w_array[1];
      $type = $w_array[2];
      $tsume = $w_array[3];
      fclose( $fp );
      return 1;
    }
  }
  fclose( $fp );
  return 0;
}
?>
