<?
  $label_array = array();
  $value_array = array();
  $way_array = array();
  $row_array = array();
  $col_array = array();

  function startElementHandler( $parser, $name, $attr )
  {
    global $label_array;
    global $way_array;
    global $col_array;
    global $row_array;
    global $current_tag;
    global $current_tx;

    $current_tag = $name;
    if ( $name == "TX-INPUT" )
    {
      $current_tx = $attr["NAME"];
      $label_array[$attr["NAME"]] = $attr["LABEL"];
      $way_array[$attr["NAME"]] = $attr["WAY"];
      $col_array[$attr["NAME"]] = $attr["COL"];
      $row_array[$attr["NAME"]] = $attr["ROW"];
    }
    else if ( $name == "EPS-INPUT" )
    {
      $current_tx = $attr["NAME"];
      $label_array[$attr["NAME"]] = $attr["LABEL"];
    }
    else
    {
    }
  }

  function endElementHandler( $parser, $name )
  {
    global $current_tag;
    if ( $current_tag == $name ) $current_tag = "";
  }

  function cdataHandler( $parser, $data )
  {
    global $value_array;
    global $current_tag;
    global $current_tx;

    if ( $current_tag == "TX-INPUT" )
    {
      $value_array[$current_tx] .= $data;
    }
    else if ( $current_tag == "EPS-INPUT" )
    {
      $value_array[$current_tx] .= $data;
    }
    else
    {
    }
  }

  function epsfilename_to_oid( $con )
  {
    global $value_array;
    while( list($key,$val) = each($value_array) )
    { 
      if ( substr($key,0,3) == "EPS" )
      {
        if ( $val == "" ) continue;
        $e = explode( ":", $val );
        $file = $e[count($e)-1];
        $p = strpos( $val, $file );
        $path = substr( $val, 0, $p );
        $qs = "select oid from image_serv where path='$path' and ".
              "filename='$file'";
        $res = sql_exec( $con, $qs );
        if ( pg_numrows($res) > 0 )
        {
          $oid = pg_result( $res, 0, "oid" );
          $value_array[$key] = $oid;
        }
        else
          $value_array[$key] = "";
      }
    }
  }

  function decode_htmlchars( $list_array )
  {
    while( list($key,$val) = each($list_array) )
    { 
      $val = str_replace( "&amp;", "&", $val );
      $val = str_replace( "&gt;", ">", $val );
      $val = str_replace( "&lt;", "<", $val );
      $val = str_replace( "&quot;", "\"", $val );
      $list_array[$key] = $val;
    }
    return( $list_array );
  }

  function oid_to_epsfilename( $con )
  {
    global $value_array;
    while( list($key,$val) = each($value_array) )
    { 
      if ( substr($key,0,3) == "EPS" )
      {
        if ( $val == "" ) continue;
        $qs = "select path, filename from image_serv where oid=$val";
        $res = sql_exec( $con, $qs );
        if ( pg_numrows($res) > 0 )
        {
          $path = pg_result( $res, 0, "path" );
          $filename = pg_result( $res, 0, "filename" );
          $value_array[$key] = $path.$filename;
        }
        else
          $value_array[$key] = "";
      }
    }
  }

  function encode_htmlchars( $value )
  {
    $val = str_replace( "\\\"", "\"", $value );
    $val = str_replace( "\\\'", "'", $val );
    $val = str_replace( "\\\\", "\\", $val );
    return(  htmlspecialchars($val) );
  }

  function load_label_info( $path )
  {
    global $label_array;
    global $value_array;
    if ( !file_exists($path) ) return;
    $fp = fopen( $path, "r" );
    if ( !$fp ) return;

    $parser = xml_parser_create();
    xml_set_element_handler( $parser, "startElementHandler",
                                      "endElementHandler" );
    xml_set_character_data_handler( $parser, "cdataHandler" );

    while( $data = fread( $fp, 4096 ) )
    {
      if ( !xml_parse( $parser, $data, feof($fp) ) )
      {
        $s = sprintf( "XML error %d:%d", xml_get_current_line_number($parser),
                      xml_get_current_column_number($parser) );
        die( $s );
      }
    }
    xml_parser_free( $parser );

    fclose( $fp );

    $label_array = decode_htmlchars( $label_array );
    $value_array = decode_htmlchars( $value_array );
//    epsfilename_to_oid( $con );
  }

  function save_label_info( $path )
  {
    global $label_array;
    global $value_array;
    global $way_array;
    global $col_array;
    global $row_array;

    if ( !$label_array ) return;

//    oid_to_epsfilename( $con );

    $fp = fopen( $path, "w" );
    if ( !$fp ) return;

    $out = "<?xml version=\"1.0\" encoding=\"EUC-JP\"?>\n";
    fwrite( $fp, $out );
    $out = "<INPUTS>\n";
    fwrite( $fp, $out );
    while( list($key,$val) = each($label_array) )
    { 
      $label = encode_htmlchars( $val );
      $data = encode_htmlchars( $value_array[$key] );
      if ( substr($key,0,3) == "EPS" )
      {
        $out = "<EPS-INPUT NAME=\"$key\" LABEL=\"$label\">".
               "$data</EPS-INPUT>\n";
      }
      else
      {
        $out = "<TX-INPUT NAME=\"$key\" LABEL=\"$label\" ".
               "WAY=\"$way_array[$key]\" ".
               "COL=\"$col_array[$key]\" ROW=\"$row_array[$key]\">".
               "$data</TX-INPUT>\n";
      }
      fwrite( $fp, $out );
    }
    $out = "</INPUTS>";
    fwrite( $fp, $out );

    fclose( $fp );
  }
?>
